<?php
function amazon_web_services_request($PrivateKey, $PublicKey, $parameters, $amz_region, $Version = "2009-03-31") {
	libxml_use_internal_errors(true);
	$uri = "/onca/xml";
	$host = "ecs.amazonaws." . $amz_region;
	$method = "GET";
	$t = time() + 10000;

	$parameters["Timestamp"] = gmdate("Y-m-d\TH:i:s\Z", $t);
	$parameters["AWSAccessKeyId"] = $PublicKey;
	$parameters["Version"] = $Version;
	$parameters["Service"] = "AWSECommerceService";

	ksort($parameters);

	$CanonicalizedQuery = array();
	foreach ($parameters as $data => $value) {
		$data = str_replace("%7E", "~", rawurlencode($data));
		$value = str_replace("%7E", "~", rawurlencode($value));
		$CanonicalizedQuery[] = $data . "=" . $value; }
	$CanonicalizedQuery = implode("&", $CanonicalizedQuery);
	$string_to_sign = $method . "\n" . $host . "\n" . $uri . "\n" . $CanonicalizedQuery;
	$signature = base64_encode(hash_hmac("sha256", $string_to_sign, $PrivateKey, True));
	$signature = str_replace("%7E", "~", rawurlencode($signature));
	$request = "http://" . $host . $uri . "?" . $CanonicalizedQuery . "&Signature=" . $signature;

	if (function_exists('curl_init')) {
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (compatible; Konqueror/4.0; Microsoft Windows) KHTML/4.0.80 (like Gecko)");
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_URL, $request);
		curl_setopt($ch, CURLOPT_TIMEOUT, 60);
		$response = curl_exec($ch);
		if (!$response) {
			$return["error"]["message"] = __("Error By cURL Error Detail : ") . curl_errno($ch) . ": " . curl_error($ch);
			return $return; }
		curl_close($ch); }
        else { $response = @file_get_contents($request);
		if (!$response) {
			$return["error"]["message"] = __("Server Error : cURL is not exist on this server!");
			return $return; } }

	$Xml = simplexml_load_string($response);
	if ($Xml === False) {
		$emessage = __("Failed loading XML, errors returned: ");
		foreach (libxml_get_errors () as $error) {
			$emessage .= $error->message . ", "; }
		libxml_clear_errors();
		$return["error"]["message"] = $emessage;
		return $return; }
        else { return $Xml; } }

function ama_create_post_posttable($intervaltype, $intervaltime, $category, $keyword, $postnow, $department, $numofpost, $AffiliateId, $cam_encoding=0, $browsenode=0, $CampaignID = 0, $minprice=0, $parent_page = 0, $asin_code = "") {
	@ini_set('memory_limit', '256M');
	@set_time_limit(0);
	global $wpdb;
	$sql_product = "select cam_camproductid from " . $wpdb->prefix . "ama_campaigns_post, `" . $wpdb->prefix . "posts` WHERE `post_ID` = `ID` AND `post_status` IN ('publish','future')"; // THIS QUERY RETURNS ALL ACTIVATED PRODUCT IDS SO WE CAN STOP REPEATED POTS.
	$productid = $wpdb->get_results($sql_product);
	$data_product = array();
	$count = 0;
	foreach ($productid as $id) {
		$data_product[] = $id->cam_camproductid;
		$count++; }
	$time = $intervaltime;
	$sql = "select * from " . $wpdb->prefix . "ama_option ";
	$api_data = $wpdb->get_results($sql);
	foreach ($api_data as $apidata) {
		$PublicKey = $apidata->api_key;
		$PrivateKey = $apidata->secret_api_key;
		$des_length = $apidata->amazon_des_length;
		$aff_web = $apidata->amazon_web; }
	$theCatId = get_term_by('name', $category, 'category');
	$category2 = $theCatId->term_id;
	$post_category = array($category2);
	$first_count = 0;
	$error_count = 0;
	$error_message = array();
	$product_error = "";
	$countpost = array();
	$filepath = dirname(__FILE__) . "/../../../.htaccess";
	$filehtacess = fopen($filepath, "a");
	$finished = false;
	$page = 1;
	do { usleep(1200000);
		if ($asin_code != "") {
			$xml = amazon_web_services_request($PrivateKey, $PublicKey, array("Operation" => "ItemLookup",
						"ItemId" => $asin_code,
						"ResponseGroup" => "Large,VariationSummary",
						"AssociateTag" => $AffiliateId), $aff_web); }
                        else { if ($department == "All") {
				$xml = amazon_web_services_request($PrivateKey, $PublicKey, array("Operation" => "ItemSearch",
							"IdType" => "ASIN",
							"MerchantId" => "All",
							"ResponseGroup" => "Large,VariationSummary",
							"SearchIndex" => $department,
							"Keywords" => $keyword,
							"ItemPage" => $page,
							"AssociateTag" => $AffiliateId), $aff_web); }
                            elseif ($browsenode != 0) { $xml = amazon_web_services_request($PrivateKey, $PublicKey, array("Operation" => "ItemSearch",
							"IdType" => "ASIN",
							"MerchantId" => "All",
							"ResponseGroup" => "Large,VariationSummary",
							"BrowseNode" => $browsenode,
							"SearchIndex" => $department,
							"Keywords" => $keyword,
							"ItemPage" => $page,
							"AssociateTag" => $AffiliateId), $aff_web); }
                            else { $xml = amazon_web_services_request($PrivateKey, $PublicKey, array("Operation" => "ItemSearch",
							"IdType" => "ASIN",
							"MerchantId" => "All",
							"ResponseGroup" => "Large,VariationSummary",
							"SearchIndex" => $department,
							"Keywords" => $keyword,
							"ItemPage" => $page,
							"AssociateTag" => $AffiliateId), $aff_web); } }

		if (isset($xml->Error->Code) || isset($xml['error']['message'])) {
			if (isset($xml->Error->Code)) {
				$error_message['message'] = '<b>' . $xml->Error->Code . '<br/>Please Check your AWS Secret Access Key and signing method</b><br/>'; }
                else { $error_message['message'] = '<b>Host not found</b>'; }
			$finished = true; }
            else {
			$qry = 'SELECT * from ' . $wpdb->prefix . 'wpd_general_settings LIMIT 1';
			$option_data = $wpdb->get_row($qry);
			$enabe_review_only_post = $option_data->enabe_review_only_post;
			$enable_link_cloaking = $option_data->enable_link_cloaking;
			foreach ($xml->Items->Item as $item) {
				$ListPrice = null;
				$LowestPrice = null;
				$ListPrice = $item->ItemAttributes->ListPrice->FormattedPrice;

				$LowestPrice = $item->OfferSummary->LowestNewPrice->FormattedPrice;
				if ($LowestPrice == null) {
					$LowestPrice = $item->Offers->Offer->OfferListing->Price->FormattedPrice; }
				if ($LowestPrice == null) {
					$LowestPrice = $item->OfferSummary->LowestUsedPrice->FormattedPrice; }
				if ($LowestPrice == null) {
					$LowestPrice = $item->OfferSummary->LowestNewPrice->FormattedPrice; }
				if ($LowestPrice == null) {
					$LowestPrice = $item->OfferSummary->LowestNewPrice->FormattedPrice; }
				if ($LowestPrice == null) {
					$LowestPrice = $item->VariationSummary->LowestPrice->FormattedPrice; }
				if ($ListPrice == null) {
					$ListPrice = $item->VariationSummary->HighestPrice->FormattedPrice; }
				if ($LowestPrice == null)
					$LowestPrice = $ListPrice;

				$pricetypearray = array('$', '', 'EUR', ',', 'CDN', '?');
				$price = (float) str_replace($pricetypearray, '', $LowestPrice);

				if (isset($item->EditorialReviews->EditorialReview->Content) && isset($item->MediumImage->URL[0]) && !(in_array($item->ASIN, $data_product)) && $LowestPrice != null && $price >= $minprice) {
					if ($intervaltype == "day") {
						$new_time = mktime(date("H"), date("i"), date("s"), date("m"), date("d") + $time, date("y"));
					} elseif ($intervaltype == "hours") {
						$new_time = mktime(date("H") + $time, date("i"), date("s"), date("m"), date("d"), date("y"));
					} else {
						$new_time = mktime(date("H"), date("i") + $time, date("s"), date("m"), date("d"), date("y")); }
					$time = $time + $intervaltime;
					$post_date = date('Y-m-d H:i:s', $new_time);
					$post_date_gmt = date('Y-m-d H:i:s', $new_time);
					$post_status = 'future';
					if ($postnow == "yes" && $first_count == 0) {
						$post_status = 'publish';
						$post_date = current_time('mysql');
						$post_date_gmt = current_time('mysql', 1);
						$first_count = 1; }
					$htacessurl = get_bloginfo('home') . '/product/' . $item->ASIN . '/';
					$post_title = $item->ItemAttributes->Title[0];
					if ($enabe_review_only_post == 1) {$kappa=$post_title;} else {$kappa="&nbsp;";}
					if ($enable_link_cloaking == 1) {
						$post_content = '<p style="float:left; margin-right:10px;"><a href="' . $htacessurl . '" rel="nofollow" target="_blank"><img src="' . $item->MediumImage->URL[0] . '" alt="' . $kappa . '"></a></p>';
					} else {
						$post_content = '<p style="float:left; margin-right:10px;"><a href="' . $item->DetailPageURL . '" rel="nofollow" target="_blank"><img src="' . $item->MediumImage->URL[0] . '" alt="' . $kappa . '"></a></p>'; }

					$CONTENT = '';
					$CONTENT = trim(substr(strip_tags($item->EditorialReviews->EditorialReview->Content[0]), 0, $des_length));
					if ($cam_encoding != 0) {
						$CONTENT = wpd_obscure($CONTENT);
					}
					$post_content.='<p>' . substr($CONTENT, 0, strrpos($CONTENT, ' ')) . '<br/></p>';
					$post_content.='<div>Sale Price:<span class="amazon_saleprice">' . str_replace('', "", $LowestPrice) . '</span></div>';
					if ($enable_link_cloaking == 1) {
						$post_content.='<p><a href="' . $htacessurl . '" rel="nofollow" target="_blank">Read More</a><a style="float:right" href="' . $htacessurl . '" rel="nofollow" target="_blank"><img src="' . AMAZON_URL . '/color/buy_now.jpg" alt="buy now"></a></p>';
					} else {
						$post_content.='<p><a href="' . $item->DetailPageURL . '" rel="nofollow" target="_blank">Read More</a><a style="float:right" href="' . $item->DetailPageURL . '" rel="nofollow" target="_blank"><img src="' . AMAZON_URL . '/color/buy_now.jpg" alt="buy now"></a></p>'; }

					$items = explode(' ', $post_title);
					$thetag = array();
					for ($k = 0, $l = count($items); $k < $l; ++$k) {
						$long = strlen($items[$k]);
						if ($long > 3) {
							$thetag[] = $items[$k]; } }
					$tags_input = array($thetag[0], $thetag[1], $thetag[2], $thetag[3], $thetag[4], $thetag[5], $thetag[6], $thetag[7], $thetag[8], $thetag[9]);
					$post_author = 1;
					$post_data = compact('post_content', 'post_title', 'post_date', 'post_date_gmt', 'post_author', 'post_category', 'post_status', 'tags_input');
					$post_data = add_magic_quotes($post_data);
					$post_ID = wp_insert_post($post_data);
					if ($parent_page > 0) {
						$parent_pages = get_post_meta($parent_page, 'page_loader', true);
						if ($parent_pages == "") {
							$parent_pages = array($post_ID);
							add_post_meta($parent_page, 'page_loader', implode(",", $parent_pages), true);
						} else {
							$parent_pages = explode(",", $parent_pages);
							$parent_pages[] = $post_ID;
							$parent_pages = array_filter($parent_pages);
							update_post_meta($parent_page, 'page_loader', implode(",", $parent_pages)); } }
					$countpost[] = array('ASIN' => $item->ASIN, 'post_ID' => $post_ID);
					if ($enable_link_cloaking == 1) {
$mira=get_bloginfo('home');
$mir=get_bloginfo('home');
$miri = "http://".$_SERVER['HTTP_HOST'];
$miniz= str_replace($miri, "", $mira);

						$htacessdata = "\n\r" . 'redirect 301 '. $miniz .'/product/' . $item->ASIN . '/  ' . str_replace(" ", "", $item->DetailPageURL) . "\n\r";
						fwrite($filehtacess, $htacessdata); }
					if (count($countpost) >= $numofpost) {
						$breck = true;
						$finished = true;
						break; } } }
			if ($page > 50) {
				if (count($countpost) < 5) {
					$finished = true; } } }
		$page++; } while (!($finished));
	fclose($filehtacess);
	if (count($countpost) == 0 && count($error_message) == 0 && !(isset($error_message['message']))) {
		$error_message['message'] = '<b>No product return Please enter valid keyword</b><br/>'; }
	if (count($error_message) == 0) {
		for ($i = 0; $i < count($countpost); $i++) {
			$sql_insert = "insert into " . $wpdb->prefix . "ama_campaigns_post(cam_postid,cam_camid,cam_camproductid,post_ID,cam_capiid)values(null,'" . $CampaignID . "','" . $countpost[$i]['ASIN'] . "','" . $countpost[$i]['post_ID'] . "','" . $AffiliateId . "')";
			$wpdb->query($sql_insert); } }
	$error_message['num_post'] = count($countpost);
	return $error_message; }
?>